#include <stdlib.h>   /* for the user i/o */
#include <math.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/types.h>

#include <sys/ioctl.h>  /* for writing to the device */
#include <sys/soundcard.h>  /* the soundcard macro definitions */

int fd;
int _seqbufptr;
int _seqbuflen;
unsigned char _seqbuf[128];

void define_buffer(int len)
{
	SEQ_DEFINEBUF(len);   /* sets up buffer size of "length" bytes */
}

void seqbuf_dump()    /* the MIDI messages get dumped here */
  {
      if (_seqbufptr)
          if (write (fd, _seqbuf, _seqbufptr) == -1) 
              printf("Can't write to MIDI device\n");
      _seqbufptr = 0;
  }

void openMIDIout(char *device)    /* actually opens the device */
{
      if ((fd = open(device, O_WRONLY)) == -1)
          printf("Can't open MIDI device\n");
      else
          printf("MIDI device is open\n");      /* verification */
} 

void closeMIDIout()
{
	close(fd);
}

void timer_start()
{   
 
     SEQ_START_TIMER();

}

void timer_stop()
{
	
     SEQ_STOP_TIMER();
 
}
 
void set_tempo (int temp)
{
     
      SEQ_SET_TEMPO(temp);

}      

void note_on (int DEVNUM, int CHAN, int note, int vol)
{
    
	SEQ_START_NOTE(DEVNUM, CHAN, note, vol);
	
}

void add_time (int ticks)
{
         
	SEQ_DELTA_TIME(ticks);    /* Play the note for dt1/100 seconds.  */
  
}

void set_time (int ticks)
{
	
	SEQ_WAIT_TIME(ticks);	/* Absolute time since timer start  */

}

                 
void seq_sync ()
{         
          ioctl(fd, SNDCTL_SEQ_SYNC);
}

void note_off (int DEVNUM, int CHAN, int note, int vol)
{
          SEQ_STOP_NOTE(DEVNUM, CHAN, note, vol);
}
          
void pitch_bend (int DEVNUM, int CHAN, int val)
{
	  SEQ_BENDER(DEVNUM, CHAN, val);
}

void set_patch (int DEVNUM, int CHAN, int patch)
{
	SEQ_SET_PATCH(DEVNUM, CHAN, patch);
}

         
   




















